unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    pb_screen: TPaintBox;
    sb_startx: TScrollBar;
    l_startx: TLabel;
    sb_endx: TScrollBar;
    l_endx: TLabel;
    sb_starty: TScrollBar;
    l_starty: TLabel;
    sb_endy: TScrollBar;
    l_endy: TLabel;
    b_mandel: TButton;
    l_pos: TLabel;
    sb_cx: TScrollBar;
    l_cx: TLabel;
    sb_cy: TScrollBar;
    l_cy: TLabel;
    b_julia: TButton;
    procedure sb_startxChange(Sender: TObject);
    procedure sb_endxChange(Sender: TObject);
    procedure sb_startyChange(Sender: TObject);
    procedure sb_endyChange(Sender: TObject);
    procedure b_mandelClick(Sender: TObject);
    procedure pb_screenMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure sb_cChange(Sender: TObject);
    procedure b_juliaClick(Sender: TObject);
    procedure pb_screenMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pb_screenMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses
  gUtils;

var
  v_startx, v_starty,
  v_endx, v_endy,
  v_cx, v_cy: real;

{$R *.DFM}

procedure TForm1.sb_startxChange(Sender: TObject);
begin
  v_startx:=sb_startx.position/100-5;
  l_startx.caption:='X1: '+floattostrf(v_startx,ffFixed,3,2);
end;

procedure TForm1.sb_endxChange(Sender: TObject);
begin
  v_endx:=sb_endx.position/100-5;
  l_endx.caption:='X2: '+floattostrf(v_endx,ffFixed,3,2);
end;

procedure TForm1.sb_startyChange(Sender: TObject);
begin
  v_starty:=sb_starty.position/100-5;
  l_starty.caption:='Y1: '+floattostrf(v_starty,ffFixed,3,2);
end;

procedure TForm1.sb_endyChange(Sender: TObject);
begin
  v_endy:=sb_endy.position/100-5;
  l_endy.caption:='Y2: '+floattostrf(v_endy,ffFixed,3,2);
end;


procedure TForm1.b_mandelClick(Sender: TObject);
var
  vp_xrun, vp_yrun, vp_zrun: integer;
  vp_x,vp_x0,vp_y,vp_y0, vp_cx, vp_cy:real;
  vp_color: o_xrgb;
begin
  vp_color.x:=0;
  gU_paint(pb_screen.canvas, v_startx, v_endx, v_starty, v_endy);
  for vp_yrun:=10 to 309 do
    for vp_xrun:=51 to 350 do
      begin
        vp_zrun:=0;
        vp_x:=v_cx;
        vp_Y:=v_cy;
        vp_cx:=gU_getx(vp_xrun);
        vp_cy:=gU_gety(vp_yrun);

        // Berechnung
        repeat
          inc(vp_zrun);
          vp_x0:=vp_x;
          vp_y0:=vp_y;
          vp_x:=sqr(vp_x0)-sqr(vp_y0)+vp_cx;
          vp_y:=vp_x0*vp_y0+vp_x0*vp_y0+vp_cy;
        until (vp_zrun=100)or(sqrt(sqr(vp_x)+sqr(vp_y))>4);

        if vp_zrun=100
          then vp_color.setrgb(clwhite)
          else
            begin
              vp_color.setrgb(clblack);
              vp_color.b:=vp_zrun*2;
            end;

{        vp_color.cliprgb;}
        pb_screen.Canvas.Pixels[vp_xrun,vp_yrun]:=vp_color.gettcolor;
      end;
end;

procedure TForm1.pb_screenMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  l_pos.caption := 'Xp: '+inttostr(x)+
                   'Yp: '+inttostr(y)+
                   'X: '+floattostrf(gU_getx(X),ffFixed,4,3)+
                   'Y: '+floattostrf(gU_gety(Y),ffFixed,4,3);
end;

procedure TForm1.sb_cChange(Sender: TObject);
begin
  v_cx:=sb_cx.position/100-5;
  l_cx.caption:='Cx: '+floattostrf(v_cx,ffFixed,3,2);
  v_cy:=sb_cy.position/100-5;
  l_cy.caption:='Cy: '+floattostrf(v_cy,ffFixed,3,2);
end;

procedure TForm1.b_juliaClick(Sender: TObject);
var
  vp_xrun, vp_yrun, vp_zrun: integer;
  vp_x,vp_x0,vp_y,vp_y0, vp_cx, vp_cy:real;
  vp_color: o_xrgb;
begin
  vp_color.x:=0;
  gU_paint(pb_screen.canvas, v_startx, v_endx, v_starty, v_endy);
  for vp_yrun:=10 to 309 do
    for vp_xrun:=51 to 350 do
      begin
        vp_zrun:=0;
        vp_x:=gU_getx(vp_xrun);
        vp_Y:=gU_gety(vp_yrun);
        vp_cx:=v_cx;
        vp_cy:=v_cy;

        // Berechnung
        repeat
          inc(vp_zrun);
          vp_x0:=vp_x;
          vp_y0:=vp_y;
          vp_x:=sqr(vp_x0)-sqr(vp_y0)+vp_cx;
          vp_y:=vp_x0*vp_y0+vp_x0*vp_y0+vp_cy;
        until (vp_zrun=100)or(sqrt(sqr(vp_x)+sqr(vp_y))>4);

        if vp_zrun=100
          then vp_color.setrgb(clwhite)
          else
            begin
              vp_color.setrgb(clblack);
              vp_color.b:=vp_zrun*2;
            end;


{        vp_color.cliprgb;}
        pb_screen.Canvas.Pixels[vp_xrun,vp_yrun]:=vp_color.gettcolor;
      end;
end;

procedure TForm1.pb_screenMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // Start-Koordinaten speichern
  v_startx:=gU_getx(x);
  sb_startx.position:=round(v_startx*100+500);
  l_startx.caption:='X1: '+floattostrf(v_startx,ffFixed,4,3);

  v_starty:=gU_gety(y);
  sb_starty.position:=round(v_starty*100+500);
  l_starty.caption:='Y1: '+floattostrf(v_starty,ffFixed,4,3);
end;

procedure TForm1.pb_screenMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  // End-Koordinaten speichern
  v_endx:=gU_getx(x);
  sb_endx.position:=round(v_endx*100+500);
  l_endx.caption:='X1: '+floattostrf(v_endx,ffFixed,4,3);

  v_endy:=gU_gety(y);
  sb_endy.position:=round(v_endy*100+500);
  l_endy.caption:='Y1: '+floattostrf(v_endy,ffFixed,4,3);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  sb_startx.Position:=400;
  sb_endx.Position:=600;
  sb_starty.Position:=400;
  sb_endy.Position:=600;
  sb_cx.Position:=500;

end;

end.
