unit gUtils;

interface

uses
  Graphics, Classes, Sysutils;

type
  o_xrgb=object
    x,r,g,b:int64;
    procedure cliprgb;
    function gettcolor:tcolor;
    procedure setrgb(color:tcolor);
  end;


procedure gU_paint(vp_canvas:tcanvas; vp_x1, vp_x2, vp_y1, vp_y2: real);

function gU_getx(vp_xppos:integer):real;
function gU_gety(vp_yppos:integer):real;

implementation


  procedure o_xrgb.cliprgb;
  begin
    if r>255 then r:=255;
    if r<0 then r:=0;
    if g>255 then g:=255;
    if g<0 then g:=0;
    if b>255 then b:=255;
    if b<0 then b:=0;
  end;

  function o_xrgb.gettcolor:tcolor;
  begin
    gettcolor:=((((((x and $FF) shl 8)+(b and $FF)) shl 8)+(g and $FF)) shl 8)+(r and $FF);
  end;

  procedure o_xrgb.setrgb(color:tcolor);
  begin
    r:=(color shr 0)and $FF;
    g:=(color shr 8)and $FF;
    b:=(color shr 16)and $FF;
    x:=(color shr 24)and $FF;
  end;

var
  v_x1, v_x2,
  v_y1, v_y2,
  v_xpp, v_ypp: real; // x per pixel

procedure gU_paint(vp_canvas:tcanvas; vp_x1, vp_x2, vp_y1, vp_y2: real);
begin
  v_x1 := vp_x1;
  v_x2 := vp_x2;
  v_xpp := (v_x2-v_x1) / 300;

  v_y1 := vp_y1;
  v_y2 := vp_y2;
  v_ypp := (v_y2-v_y1) / 300;


  with vp_canvas do begin
    // Zeichenflche schwarz:
    brush.color:=clblack;
    FillRect(vp_canvas.ClipRect);

    // Koordinatenkreuz einzeichnen
    pen.Color:=clwhite;
    moveto(50,5);
    lineto(50,315);
    moveto(45,310);
    lineto(355,310);

    moveto(45,10);
    lineto(55,10);
    moveto(350,305);
    lineto(350,315);

    // Beschriftung
    font.Color:=clwhite;
    TextOut(35,320,floattostrf(vp_x1,ffFixed,4,3));
    TextOut(335,320,floattostrf(vp_x2,ffFixed,4,3));

    TextOut(5,305,floattostrf(vp_y1,ffFixed,4,3));
    TextOut(5,5,floattostrf(vp_y2,ffFixed,4,3));

  end;
end;

function gU_getx(vp_xppos:integer):real;
begin
  gU_getx:=v_x1+v_xpp*(vp_xppos-50);
end;

function gU_gety(vp_yppos:integer):real;
begin
  gU_gety:=v_y1+v_ypp*(310-vp_yppos);
end;

end.
